/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

/*
 * VertexSetupFrame.java
 *
 * Created on Apr 25, 2012, 2:45:54 PM
 */

package monalisa.addons.netviewer;

import monalisa.addons.util.MyWindowListener;
import monalisa.resources.ResourceManager;
import monalisa.resources.StringResources;

/**
 *
 * @author Jens Einloft
 */
public class VertexSetupFrame extends javax.swing.JFrame {
    private static final long serialVersionUID = -1522812473959407238L;

    /** Creates new form VertexSetupFrame */
    public VertexSetupFrame(NetViewer netViewer) {
        this.netViewer = netViewer;
        initComponents();
        showColorLabelVertex.addMouseListener(new MyColorOptionsMouseListener(showColorLabelVertex));
        addWindowListener(new MyWindowListener(this.netViewer));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        shapeBG = new javax.swing.ButtonGroup();
        labelPositionButtons = new javax.swing.ButtonGroup();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel1 = new javax.swing.JPanel();
        vertexNameLabel = new javax.swing.JLabel();
        vertexTypeLabel = new javax.swing.JLabel();
        shapeLabel = new javax.swing.JLabel();
        circleRadioButon = new javax.swing.JRadioButton();
        polygoneRadioButton = new javax.swing.JRadioButton();
        cornerSpinner = new javax.swing.JSpinner();
        sytleLabel = new javax.swing.JLabel();
        nameLabel = new javax.swing.JLabel();
        vertexNameTextField = new javax.swing.JTextField();
        colorLabel = new javax.swing.JLabel();
        showColorLabelVertex = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        vertexNoteTextArea = new javax.swing.JTextArea();
        hintLabel = new javax.swing.JLabel();
        lablePositionLabel = new javax.swing.JLabel();
        rbPanel = new javax.swing.JPanel();
        W = new javax.swing.JRadioButton();
        C = new javax.swing.JRadioButton();
        NW = new javax.swing.JRadioButton();
        N = new javax.swing.JRadioButton();
        SW = new javax.swing.JRadioButton();
        SE = new javax.swing.JRadioButton();
        S = new javax.swing.JRadioButton();
        NE = new javax.swing.JRadioButton();
        E = new javax.swing.JRadioButton();
        noteLabel = new javax.swing.JLabel();
        saveButton = new javax.swing.JButton();

        setTitle("Vertex Setup");
        setIconImage(resources.getImage("icon-16.png"));

        jPanel1.setPreferredSize(new java.awt.Dimension(290, 290));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        vertexNameLabel.setFont(new java.awt.Font("Cantarell", 1, 14)); // NOI18N
        vertexNameLabel.setText("jLabel1");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(19, 0, 10, 20);
        jPanel1.add(vertexNameLabel, gridBagConstraints);
        vertexNameLabel.getAccessibleContext().setAccessibleName("vertexName");

        vertexTypeLabel.setFont(new java.awt.Font("Cantarell", 1, 14)); // NOI18N
        vertexTypeLabel.setForeground(java.awt.Color.red);
        vertexTypeLabel.setText("jLabel2");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(19, 20, 10, 0);
        jPanel1.add(vertexTypeLabel, gridBagConstraints);

        shapeLabel.setFont(new java.awt.Font("Cantarell", 1, 14)); // NOI18N
        shapeLabel.setText("Shape");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 5, 0);
        jPanel1.add(shapeLabel, gridBagConstraints);

        shapeBG.add(circleRadioButon);
        circleRadioButon.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        circleRadioButon.setText("Circle");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 20);
        jPanel1.add(circleRadioButon, gridBagConstraints);

        shapeBG.add(polygoneRadioButton);
        polygoneRadioButton.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        polygoneRadioButton.setText("Polygone");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        jPanel1.add(polygoneRadioButton, gridBagConstraints);

        cornerSpinner.setModel(new javax.swing.SpinnerNumberModel(3, 3, 7, 1));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel1.add(cornerSpinner, gridBagConstraints);

        sytleLabel.setFont(new java.awt.Font("Cantarell", 1, 14)); // NOI18N
        sytleLabel.setText("Style");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        jPanel1.add(sytleLabel, gridBagConstraints);

        nameLabel.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        nameLabel.setText("Name:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 0);
        jPanel1.add(nameLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.ipadx = 214;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 20);
        jPanel1.add(vertexNameTextField, gridBagConstraints);

        colorLabel.setFont(new java.awt.Font("Cantarell", 0, 14)); // NOI18N
        colorLabel.setText("Color:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 0);
        jPanel1.add(colorLabel, gridBagConstraints);

        showColorLabelVertex.setText(strings.get("NVColorLabelDummy"));
        showColorLabelVertex.setOpaque(true);
        showColorLabelVertex.setPreferredSize(new java.awt.Dimension(50, 15));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanel1.add(showColorLabelVertex, gridBagConstraints);

        vertexNoteTextArea.setColumns(20);
        vertexNoteTextArea.setRows(5);
        jScrollPane2.setViewportView(vertexNoteTextArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 253;
        gridBagConstraints.ipady = 154;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 20);
        jPanel1.add(jScrollPane2, gridBagConstraints);

        hintLabel.setFont(new java.awt.Font("Cantarell", 0, 10)); // NOI18N
        hintLabel.setText("(click to change)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 3, 0, 20);
        jPanel1.add(hintLabel, gridBagConstraints);

        lablePositionLabel.setFont(new java.awt.Font("Cantarell", 1, 14)); // NOI18N
        lablePositionLabel.setText("Label position");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        jPanel1.add(lablePositionLabel, gridBagConstraints);

        rbPanel.setLayout(new java.awt.GridBagLayout());

        labelPositionButtons.add(W);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        rbPanel.add(W, gridBagConstraints);

        labelPositionButtons.add(C);
        C.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        rbPanel.add(C, gridBagConstraints);

        labelPositionButtons.add(NW);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        rbPanel.add(NW, gridBagConstraints);

        labelPositionButtons.add(N);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        rbPanel.add(N, gridBagConstraints);

        labelPositionButtons.add(SW);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
        rbPanel.add(SW, gridBagConstraints);

        labelPositionButtons.add(SE);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        rbPanel.add(SE, gridBagConstraints);

        labelPositionButtons.add(S);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
        rbPanel.add(S, gridBagConstraints);

        labelPositionButtons.add(NE);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        rbPanel.add(NE, gridBagConstraints);

        labelPositionButtons.add(E);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        rbPanel.add(E, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 109;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 20, 0, 20);
        jPanel1.add(rbPanel, gridBagConstraints);

        noteLabel.setFont(new java.awt.Font("Cantarell", 1, 14)); // NOI18N
        noteLabel.setText("Note:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        jPanel1.add(noteLabel, gridBagConstraints);

        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 20, 20);
        jPanel1.add(saveButton, gridBagConstraints);

        jScrollPane1.setViewportView(jPanel1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 330, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 600, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        if(this.netViewer.selection4Modification.isEmpty())
            this.netViewer.saveVertexSetup();
        else
            this.netViewer.saveVerticesSetup();
    }//GEN-LAST:event_saveButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JRadioButton C;
    protected javax.swing.JRadioButton E;
    protected javax.swing.JRadioButton N;
    protected javax.swing.JRadioButton NE;
    protected javax.swing.JRadioButton NW;
    protected javax.swing.JRadioButton S;
    protected javax.swing.JRadioButton SE;
    protected javax.swing.JRadioButton SW;
    protected javax.swing.JRadioButton W;
    protected javax.swing.JRadioButton circleRadioButon;
    private javax.swing.JLabel colorLabel;
    protected javax.swing.JSpinner cornerSpinner;
    private javax.swing.JLabel hintLabel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    protected javax.swing.ButtonGroup labelPositionButtons;
    private javax.swing.JLabel lablePositionLabel;
    private javax.swing.JLabel nameLabel;
    private javax.swing.JLabel noteLabel;
    protected javax.swing.JRadioButton polygoneRadioButton;
    private javax.swing.JPanel rbPanel;
    private javax.swing.JButton saveButton;
    private javax.swing.ButtonGroup shapeBG;
    private javax.swing.JLabel shapeLabel;
    protected javax.swing.JLabel showColorLabelVertex;
    private javax.swing.JLabel sytleLabel;
    protected javax.swing.JLabel vertexNameLabel;
    protected javax.swing.JTextField vertexNameTextField;
    protected javax.swing.JTextArea vertexNoteTextArea;
    protected javax.swing.JLabel vertexTypeLabel;
    // End of variables declaration//GEN-END:variables

    private static final ResourceManager resources = ResourceManager.instance();
    private static final StringResources strings = resources.getDefaultStrings();

    private NetViewer netViewer;
}
