/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

package monalisa.addons.netviewer;

import java.io.Serializable;


/**
 * Saves a graph and his layout
 * @author Jens Einloft
 */
public class View implements Serializable {
    private static final long serialVersionUID = -7677602317098004805L;
    
    private String name;
    private byte[] layout;
    private byte[] graph;
    private byte[] results;

    public View(String name, byte[] layout, byte[] graph, byte[] results) {
        this.name = name;
        this.layout = layout;
        this.graph = graph;
        this.results = results;
    }

    public byte[] getGraph() {
        return graph;
    }

    public byte[] getLayout() {
        return layout;
    }

    public byte[] getResults() {
        return results;
    }

    public void setResults(byte[] results) {
        this.results = results;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public String toString() {
        return this.name;
    }
}
