/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

package monalisa.addons.netviewer;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * Wrapper for all views
 * @author Jens Einloft
 */
public class ViewWrapper implements Serializable {
    private static final long serialVersionUID = -8257981726172294151L;
    
    private List<View> wrapper = new ArrayList<View>();

    public View addView(String name, byte[] layout, byte[] graph, byte[] results) {
        View view = new View(name, layout, graph, results);
        wrapper.add(view);
        return view;
    }
    
    public void addView(View view) {
        wrapper.add(view);
    }

    public int getViewCounter() {
        return wrapper.size();
    }

    public List<View> getViews() {
        return wrapper;
    }

    public void removeView(View view) {
        wrapper.remove(view);
    }

    public void replaceView(View oldView, View newView) {
        wrapper.remove(oldView);
        wrapper.add(newView);
    }
}
